local chatInputActive = false
local chatInputActivating = false
local chatOn = true

RegisterNetEvent('chatMessage')
RegisterNetEvent('chat:addTemplate')
RegisterNetEvent('chat:addMessage')
RegisterNetEvent('chat:addSuggestion')
RegisterNetEvent('chat:removeSuggestion')
RegisterNetEvent('chat:clear')

-- internal events
RegisterNetEvent('__cfx_internal:serverPrint')

RegisterNetEvent('_chat:muitzaqmessageEntered')

--deprecated, use chat:addMessage
AddEventHandler('chatMessage', function(author, color, text)
  if chatOn then
  local args = { text }
  if author ~= "" then
    table.insert(args, 1, author)
  end
  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = {
      color = color,
      multiline = true,
      args = args
    }
  })
  end
end)

AddEventHandler('__cfx_internal:serverPrint', function(msg)
  print(msg)

  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = {
      color = { 0, 0, 0 },
      multiline = true,
      args = { msg }
    }
  })
end)

AddEventHandler('chat:addMessage', function(message)
  SendNUIMessage({
    type = 'ON_MESSAGE',
    message = message
  })
end)

RegisterCommand("cleanskin", function()
  local ped = PlayerPedId()
  ClearPedBloodDamage(ped)
  ResetPedVisibleDamage(ped)
  ClearPedWetness(ped)
  ClearPedEnvDirt(ped)
end)

AddEventHandler('chat:addSuggestion', function(name, help, params)
  SendNUIMessage({
    type = 'ON_SUGGESTION_ADD',
    suggestion = {
      name = name,
      help = help,
      params = params or nil
    }
  })
end)

AddEventHandler('chat:removeSuggestion', function(name)
  SendNUIMessage({
    type = 'ON_SUGGESTION_REMOVE',
    name = name
  })
end)

AddEventHandler('chat:addTemplate', function(id, html)
  SendNUIMessage({
    type = 'ON_TEMPLATE_ADD',
    template = {
      id = id,
      html = html
    }
  })
end)

AddEventHandler('chat:clear', function(name)
  SendNUIMessage({
    type = 'ON_CLEAR'
  })
end)

spamDetection = 0
spamDetected = 0

RegisterNUICallback('chatResult', function(data, cb)
	chatInputActive = false
	SetNuiFocus(false)

	if not data.canceled then
		local id = PlayerId()

		--deprecated
		local r, g, b = 0, 0x99, 255

		if data.message:sub(1, 1) == '/' then
			ExecuteCommand(data.message:sub(2))
		else
			if(spamDetection < 3)then
				spamDetection = spamDetection + 1
				TriggerServerEvent('_chat:muitzaqmessageEntered', GetPlayerName(id), { r, g, b }, data.message)
			else
				if(spamDetected < 5)then
					spamDetected = spamDetected + 1
					TriggerEvent("chatMessage", "[SPAM]", {255, 0, 0}, "Spam detectat! Continuarea spamului va duce la kick!")
				else
					TriggerServerEvent('chat:kickSpammer')
				end
			end
		end
	end
  cb('ok')
end)

Citizen.CreateThread(function()
	while true do
		Wait(3000)
		if(spamDetection > 0)then
			spamDetection = 0
		end
	end
end)

Citizen.CreateThread(function()
	while true do
		Wait(9000)
		if(spamDetected == 5)then
			spamDetection = 0
		end
	end
end)

RegisterNUICallback('loaded', function(data, cb)
  TriggerServerEvent('chat:init');

  cb('ok')
end)

RegisterCommand("keymapping:chat", function ()
  SetTextChatEnabled(false)
  SetNuiFocus(false)
    if not chatInputActive then
        chatInputActive = true
        chatInputActivating = true

        SendNUIMessage({
          type = 'ON_OPEN'
        })
    end

    if chatInputActivating then
        SetNuiFocus(true)

        chatInputActivating = false
      end
end)

RegisterKeyMapping("keymapping:chat", "Chat", "keyboard", "T")

local inSafeZone = false
local safeZone = nil

local safeZones = {
	["spawn"] = {pos =vector3(-540.54827880859,-211.54513549805,37.645694732666), radius = 100.0},
	["spital"] = {pos =vector3(292.45074462891,-600.09149169922,43.301261901855), radius = 70.0},
	["showroom"] = {pos =vector3(-50.050079345703,-1100.9970703125,26.46724319458), radius = 90.0},
}

local aparut = false

CreateThread(function()
  CreateThread(function()
      local ticks = 1000
      while true do
          local ped = PlayerPedId()

          if (inSafeZone) then
              ticks = 5
              if aparut == false then
                  aparut = true
                  SendNUIMessage({
                      action = "safezone",
                      stil = 'block'
                  })
              end
  
              DisableControlAction(0,24,true)
              DisableControlAction(0,25,true)
              DisableControlAction(0,47,true)
              DisableControlAction(0,58,true)
              DisableControlAction(0,263,true)
              DisableControlAction(0,264,true)
              DisableControlAction(0,257,true)
              DisableControlAction(0,140,true)
              DisableControlAction(0,141,true)
              DisableControlAction(0,142,true)
              DisableControlAction(0,143,true)
  
              SetEntityAlpha(ped, 225, false)
              SetEntityInvincible(ped, true)
              SetEntityInvincible(PlayerId(), true)
              ResetPedVisibleDamage(ped)
              ClearPedBloodDamage(ped)
              SetEntityCanBeDamaged(ped, false)
              NetworkSetFriendlyFireOption(false)

              if IsPedInAnyVehicle(ped, false) then
                local vehicle = GetVehiclePedIsIn(ped, false)
                local currentSpeed = GetEntitySpeed(vehicle) * 3.6 
    
                if currentSpeed > 27.6 then
                    SetEntityMaxSpeed(vehicle, 27.6)
                end
              end

          else
              if aparut == true then
                  aparut = false
                  SendNUIMessage({
                      action = "safezone",
                      stil = 'none'
                  })
              end
              ticks = 1000
              SetEntityAlpha(ped, 255, false)
              SetEntityInvincible(ped, false)
              SetEntityInvincible(PlayerId(), false)
              SetEntityCanBeDamaged(ped, true)
              NetworkSetFriendlyFireOption(true)

              if IsPedInAnyVehicle(ped, false) then
                local vehicle = GetVehiclePedIsIn(ped, false)
                SetEntityMaxSpeed(vehicle, 540.0)
              end
  
          end
          Wait(ticks)
          ticks = 1000
      end
  end)
  while true do
      Wait(1000)
      local ped = PlayerPedId()
      local coords = GetEntityCoords(ped)


      SendNUIMessage({
          pId = (Player(GetPlayerServerId(PlayerId())).state.user_id),
          useriOn = GlobalState.onlinePlayers
      })


      for key,value in pairs(safeZones) do
          pos = value.pos
          radius = value.radius
          if #(coords - pos) < radius then
              inSafeZone = true
              safeZone = key
          end
      end
      if safeZone ~= nil then
          pos = safeZones[safeZone].pos
          radius = safeZones[safeZone].radius
          if #(pos - coords) > radius then
              inSafeZone = false
              safeZone = nil
          end
      end
  end
end)


local greenZones = {
	{pos = vector3(-30.15495300293,-1103.8315429688,26.422359466553), radius = 100.0}, -- showroom
  {pos = vector3(292.45074462891,-600.09149169922,43.301261901855),  radius = 70.0}, -- spital
  {pos = vector3(-540.54827880859,-211.54513549805,37.645694732666),  radius = 90.0}, -- spawn
  {pos = vector3(151.39605712891,-1036.1080322266,29.3392162323),  radius = 60.0}, -- spawn
}


Citizen.CreateThread(function()
    while true do
        Citizen.Wait(1000)
        local plyPos = GetEntityCoords(PlayerPedId())
        for _, zone in pairs(greenZones) do
          local dst = (IsPauseMenuActive() and 0.0) or GetDistanceBetweenCoords(plyPos, zone.pos, false)
          local minDst = math.max(zone.radius) + 10.0
          if not zone.blip and dst <= minDst then
              zone.blip = AddBlipForRadius(zone.pos, zone.radius)
              SetBlipColour(zone.blip, 69)
              SetBlipAlpha(zone.blip, 100)
          elseif dst > minDst then
              RemoveBlip(zone.blip)
              zone.blip = nil
          end
        end
    end
end)

local pompModellen = {
  [`prop_gas_pump_1b`] = true,
  [`prop_gas_pump_1c`] = true,
  [`prop_gas_pump_old2`] = true,
  [`prop_gas_pump_1d`] = true,
  [`prop_gas_pump_1a`] = true,
  [`prop_vintage_pump`] = true,
  [`prop_gas_pump_old3`] = true
}

function FindNearestFuelPump()
  local coords = GetEntityCoords(PlayerPedId())
  local pompObject = 0
  local pompAfstand = 1000
  local objects = GetGamePool("CObject")
  local staat, resultaat = xpcall(function()
      local tel = 0
      for i=1, #objects do
          if tel % 30 == 0 then
              Wait(0)
          end
          tel = tel + 1
          if pompModellen[GetEntityModel(objects[i])] then
              SetEntityCollision(objects[i], false, false)
              local afstandcontroleren = #(coords - GetEntityCoords(objects[i]))
          
              if afstandcontroleren < pompAfstand then
                  pompAfstand = afstandcontroleren
                  pompObject = objects[i]
              end
          end
      end
  end, debug.traceback)
  if not staat then
      print(("Error" .. resultaat))
  end
  return pompObject, pompAfstand
end

Citizen.CreateThread(function()
  while true do
      Wait(2000)
      local pompObject, pompAfstand = FindNearestFuelPump()
      if pompAfstand < 3.0 then
          isNearPump = pompObject
      else
          isNearPump = false
          Wait(math.ceil(pompAfstand * 3))
      end
  end
end)